%projectileSpeed = 100;

datablock AudioDescription(AudioDefault3dLonger : AudioDefault3d)
{
	maxDistance = 190;
	referenceDistance = 120;
};

datablock AudioDescription(AudioDefaultLooping3dLonger : AudioDefaultLooping3d)
{
	maxDistance = 190;
	referenceDistance = 120;
};

datablock AudioProfile(inhaleSound)
{
	filename    = "./inhale.wav";
	description = AudioDefault3D;
	preload = true;
};
datablock AudioProfile(combBendFireSound)
{
	filename    = "./fire.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(combBendExplosionSound)
{
	filename    = "./explosion.wav";
	description = AudioDefault3dLonger;
	preload = true;
};
datablock AudioProfile(combBendProjectileSound)
{
	filename = "./projectile.wav";
	description = AudioDefaultLooping3dLonger;
	preload = true;
};
//////////////////////////
//forehead firing effect//
//////////////////////////
datablock ParticleData(combBendFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/ring";
	spinSpeed			 = 0.0;
	spinRandomMin		 = -500.0;
	spinRandomMax		 = 500.0;
	colors[0]    		 = "1.0 0.5 0.0 1.0";
	colors[1]   		 = "1.0 1.0 1.0 0.01";
	sizes[0]    		 = 0.01;
	sizes[1]    		 = 3.5;
	
	useInvAlpha = false;
};
datablock ParticleEmitterData(combBendFlashEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = false;
   particles 		= "combBendFlashParticle";

   uiName 		= "Combustion Bend Release";
};
/////////
//TRAIL//
/////////
datablock ParticleData(combBendTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "base/data/particles/ring";

	// colors[1]	= "1 .75 5 0.5";
	colors[0]	= "1 1 1 0.08";
	colors[1]	= "1 .5 0 0.08";
	colors[2]	= "1 1 1 0.08";
	colors[3]	= "1 1 1 0.08";
	sizes[0]	= 0.2;
	sizes[1]	= 1.0;
	sizes[2]	= 0.23;
	sizes[3]	= 0.3;

	times[0]	= 0.00;
	times[1]	= 0.04;
	times[2]    = 0.08;
	times[3]    = 1.0;
};
datablock ParticleEmitterData(combBendTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;

	ejectionVelocity = 0;
	velocityVariance = 0;

	ejectionOffset = 0;

	thetaMin         = 0.0;
	thetaMax         = 90.0;  

	particles = combBendTrailParticle;

	useEmitterColors = true;
	uiName = "Combustion Trail";
};
/////////////////////////////
//PRIMARY EXPLOSION DETAILS//
/////////////////////////////
//Steal merrily from the beautiful main vehicle explosion
datablock ParticleData(combBendExplosionParticle3 : vehicleFinalExplosionParticle3)
{//this is the star
	sizes[0] = "5";
	sizes[1] = "30";
};

datablock ParticleEmitterData(combBendExplosionEmitter3 : vehicleFinalExplosionEmitter3)
{
	particles = combBendExplosionParticle3;
};

//2 is the orange clouds on the ground!
datablock ParticleData(combBendExplosionParticle2 : vehicleFinalExplosionParticle2)
{
	sizes[0] = "2.5";
	sizes[1] = "5.0";
};

datablock ParticleEmitterData(combBendExplosionEmitter2 : vehicleFinalExplosionEmitter2)
{
	particles = combBendExplosionParticle2;
	ejectionVelocity = 30;//default is 30
	ejectionPeriodMS = "1";//default is 1
	lifetimeMS = 150;//default is 15
};
/////////////////////
//PRIMARY EXPLOSION//
/////////////////////
datablock ExplosionData(combBendExplosion : vehicleFinalExplosion)
{
	explosionShape = "./explosionSphere1.dts";

	emitter[0] = "combBendExplosionEmitter3";//STAR
	emitter[1] = "combBendExplosionEmitter2";//RED CHUNK SHIT

	particleEmitter = vehicleFinalExplosionEmitter;//BLACK CLOUDS

	particleDensity = 30;

	debrisVelocity = "4";
	particleRadius = "2";
	explosionScale = "1 1 1";
	soundProfile = combBendExplosionSound;

	damageRadius = 7;
	radiusDamage = 90;

	impulseRadius = 11;
	impulseForce = 3000;

	lightStartRadius = 10;
	lightEndRadius = 15;
	lightStartColor = "1.0 0.7 0.3 1.0";
	lightEndColor   = "1.0 0.5 0.0 0.5";
};

//First is ID, second is direct, third is radius, and fourth applies the names or something
AddDamageType("combBend",   '<bitmap:add-ons/Weapon_Combustion_Bending/ci_spark> %1',
    '%2 <bitmap:add-ons/Weapon_Combustion_Bending/ci_spark> %1',0.2,1);
//////////////////////
//PRIMARY PROJECTILE//
//////////////////////
datablock ProjectileData(combBendProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 90;
   directDamageType    = $DamageType::combBend;
   radiusDamageType    = $DamageType::combBend;

   sound	       = combBendProjectileSound;

   brickExplosionRadius = 8;
   brickExplosionImpact = false;
   brickExplosionForce  = 38;
   brickExplosionMaxVolume = 55;
   brickExplosionMaxVolumeFloating = 100;

   impactImpulse	   = 400;
   verticalImpulse	   = 400;
   explosion           = combBendExplosion;
   particleEmitter     = combBendTrailEmitter;

   muzzleVelocity      = %projectileSpeed;
   velInheritFactor    = 0;

   armingDelay         = 00;// >0 wouldnt be very accurate to the story would it now?
   lifetime            = 1350;

   isBallistic         = false;
   fadeDelay           = 3500;

   explodeOnDeath = 1;

   hasLight    = true;
   lightRadius = 7.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Combustion Bending charge";
};

////////////////////////
//POP TRAIL PROJECTILE//
////////////////////////
datablock ParticleData(combBendFlashTrailParticle : combBendFlashParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0;
	gravityCoefficient	= 0;
	lifetimeMS          = 700;
	colors[0]   		 = "1.0 1.0 1.0 0.5";
	colors[0]   		 = "1.0 1.0 1.0 0.5";
	times[0]			= 0;
	times[1]			= 1;
	sizes[0]			= 4;
	sizes[1]			= 4;
};
datablock ParticleEmitterData(combBendFlashTrailEmitter : combBendFlashEmitter)
{
	particles = combBendFlashTrailParticle;
	ejectionPeriodMS = 150;
	thetaMax         = 0;
	useEmitterColors = false;
};
datablock ProjectileData(combBendPopTrailProjectile)//smaller thing that follows
{
	projectileShapeName = "base/data/shapes/empty.dts";
	isBallistic         = false;
	muzzleVelocity      = %projectileSpeed;
	fadeDelay           = 0;
	hasLight 			= false;
	lifetime            = 1300;
	explodeOnDeath		= 1;
	particleEmitter     = combBendFlashTrailEmitter;
	
	uiName = "Combustion Bending Pop Trail";
};

//////////
//ITEM////
//////////
datablock ItemData(combBendItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./eyeExportable.dts";//model that gets picked up
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Spark Bend";//Inventory name (needs to fit)
	iconName = "./icon_tattoo";
	doColorShift = false;//Ie gun icon color shift

	image = combBendImage;

	canDrop = true;
};

////////////////
//WEAPON IMAGE//
////////////////
datablock ShapeBaseImageData(combBendImage)
{
	// Basic Item properties
	shapeFile = "./eyeExportable.dts";//make the actual eye
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 5;
	offset = "0 .2 .22"; //left/right, back/front, down/up
	eyeOffset = "0 0 .2";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off. lolno
	correctMuzzleVector = true;

	className = "WeaponImage";

	// Projectile && Ammo.
	item = BowItem;
	ammo = " ";
	projectile = combBendProjectile;
	projectileType = Projectile;

	casing = "";

	//melee particles shoot from eye node for consistency
	melee = false;

	//raise your arm upon inventory selection up or not
	armReady = 0;

	doColorShift = false;

	//State stuff
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]				= weaponSwitchSound;

	stateName[1]			= "Ready";//player presses fire button
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";//when it hits timeout value
	stateTimeoutValue[2]            = 1.1;//player must hold longer than this time
	stateSequence[2]		= "Charge";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";//else this happens
	stateSound[2]					= inhaleSound;
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";//This happens if fails
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 1.2;//0.6
	stateFire[3]			= true;
	stateSequence[3]		= "Fire";
	stateScript[3]			= "onFiretwo";
	stateWaitForTimeout[3]		= true;
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";//waited long enough!
	stateTransitionOnTriggerUp[4]	= "Fire";//release to shoot!
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";//FIRE!
	stateTransitionOnTimeout[5]	= "Ready";//now go back to ready
	stateEmitter[5]					= combBendFlashEmitter;
	stateEmitterTime[5]				= 0.01;
	stateEmitterNode[5]				= "muzzleNode";
	stateTimeoutValue[5]		= 0.5;//0.2
	stateFire[5]			= true;
	stateSequence[5]		= "Fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= combBendFireSound;
};


////////
//BEAM//
////////
datablock ExplosionData(crackExplosion)
{
	explosionShape = "./explosionSphere1.dts";

	lifeTimeMS = 350;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
		camShakeFreq = "10.0 11.0 10.0";
		camShakeAmp = "2.5 2.5 2.5";
		camShakeDuration = 0.2;
		camShakeRadius = 20.0;
   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 10;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 1";

   damageRadius = 1;
   radiusDamage = 30;

   impulseRadius = 4;
   impulseForce = 2500;
};

datablock ProjectileData(miniCrackProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = 50;
	directDamageType    = $DamageType::combBend;
	radiusDamageType    = $DamageType::combBend;


	brickExplosionRadius = 4;
	brickExplosionImpact = true;
	brickExplosionForce  = 20;
	brickExplosionMaxVolume = 30;
	brickExplosionMaxVolumeFloating = 50;

	impactImpulse	   = 100;
	verticalImpulse	   = 100;
	explosion           = crackExplosion;

	muzzleVelocity      = %projectileSpeed*0.80;
	velInheritFactor    = 0;

	armingDelay         = 500;
	lifetime            = 1000;//first crack! 550, second is 910

	isBallistic         = false;
	fadeDelay           = 3500;

	explodeOnDeath = 1;

	hasLight    = false;

	uiName = "Combustion Bending mini charge";
};
function miniCrackProjectile::onCollision(%this,%obj,%col)
{
	%obj.delete();
	Parent::onCollision(%this,%obj,%col);
}

function combBendImage::onFire(%this,%obj,%slot){
	%Projectile = miniCrackProjectile;
	%spread = 0.00001;
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %Projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %Projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);//what the fuck is this?
	%velocity = MatrixMulVector(%mat, %velocity);

	%shellcount = 2;//for distance, first crack 550, second is 910
	%distance = 200;//difference is 360, add each time to get proper timing,
	for(%shell=0; %shell<%shellcount; %shell++)//for(int i = 0; i < list.length(); i++){}!
	{
		%p = new (%this.projectileType)()
		{
			dataBlock = %Projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		%distance = %distance + 360;
		%p.schedule(%distance, explode);
		MissionCleanup.add(%p);
	}
	%p = new (%this.projectileType)()//Pop trail
	{
		dataBlock = combBendPopTrailProjectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);//create pop trail
	Parent::onFire(%this,%obj,%slot);
	return %p;
}

function combBendItem::onUse(%this, %obj, %slot){//item, player, slot
	%obj.updateArm(%obj, combBendImage);
	%obj.mountImage(combBendImage, 0);
}
function combBendImage::onMount(%this, %obj, %slot){
	%obj.playThread(1, root);//1 = arm animation slot, not second mount
	%obj.hidenode(helmet);
	%obj.hidenode(cophat);
	%obj.hidenode(knitHat);
	%obj.hidenode(scoutHat);
	%obj.hidenode(bicorn);
	%obj.hidenode(pointyHelmet);
	%obj.hidenode(flareHelmet);
	%obj.hidenode(plume);
	%obj.hidenode(triplume);
	%obj.hidenode(septplume);
	%obj.hidenode(visor);
}
function combBendImage::onUnmount(%this, %obj, %slot){
	%obj.client.applyBodyParts();
	Parent::onUnmount(%this, %obj, %slot);
}